Revit, как получить положение, длину и высоту в выбранной стене - PullRequest
2 голосов
/ 12 июля 2011

У меня есть этот код, и я не знаю, как отобразить положение, высоту и длину выбранной стены:

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Autodesk.Revit.DB;
using Autodesk.Revit.DB.Architecture;
using Autodesk.Revit.UI;
using Autodesk.Revit.UI.Selection;
using Autodesk.Revit.ApplicationServices;
using Autodesk.Revit.Attributes;
namespace PickSelectionFiltered
{
    [TransactionAttribute(TransactionMode.Manual)]
    [RegenerationAttribute(RegenerationOption.Manual)] 

    public class Class1: IExternalCommand
    {
        public class MySelectionFilter : ISelectionFilter
        {
            Document m_doc = null;

            public bool AllowElement(Element element)
            {
                return element is Wall;
            }
            public bool AllowReference(Reference refer, XYZ point)
            {
                GeometryObject geoObject = 
                m_doc.GetElement(refer)
                     .GetGeometryObjectFromReference(refer);
                return geoObject != null && geoObject is Face;
            }
        }


        public Result Execute(ExternalCommandData commandData, 
          ref string message, ElementSet elements)
        {
            //Get application and document objects
            UIDocument uidoc = commandData.Application.ActiveUIDocument;

            try
            {
                while (true)
                {
                    Reference selRef = 
                      uidoc.Selection.PickObject(ObjectType.Element, 
                        new MySelectionFilter(), "select a room");
                    /*
                     * Add the code to get position, lenght and height
                     * */
                }

            } catch (Autodesk.Revit.Exceptions.OperationCanceledException) { }

            return Result.Succeeded;
        }
    }
}

1 Ответ

4 голосов
/ 18 июля 2011

Положение стены основано на ее кривой движения, полученной из стены как LocationCurve:

Wall wall = document.GetReference(setRef) as Wall;
if (wall != null)
{
    LocationCurve locationCurve = wall.Location as LocationCurve;
    XYZ endPoint0 = locationCurve.Curve.get_EndPoint[0];
    XYZ endPoint1 = locationCurve.Curve.get_EndPoint[1];
} 

Длина стены получена из параметра стены:

BuiltInParameter.CURVE_ELEM_LENGTH

Ширина стены получена из параметра типа стены:

BuiltInParameter.WALL_ATTR_WIDTH_PARAM

Это для стандартной стены и не будет применяться к специальным типам стен, таким как навесные стены и сложенные стены.

...